"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.lsk = void 0;
const cryptography = __importStar(require("@liskhq/lisk-cryptography"));
const sodium_browserify_tweetnacl_1 = __importDefault(require("sodium-browserify-tweetnacl"));
const pbkdf2_1 = __importDefault(require("pbkdf2"));
const encryptor_1 = require("../helpers/encryptor");
const LiskHashSettings = {
    SALT: 'adm',
    ITERATIONS: 2048,
    KEYLEN: 32,
    DIGEST: 'sha256',
};
const network = {
    name: 'Lisk',
    port: 8000,
    wsPort: 8001,
    unit: 'LSK',
};
exports.lsk = {
    keys: (passphrase) => {
        const liskSeed = pbkdf2_1.default.pbkdf2Sync(passphrase, LiskHashSettings.SALT, LiskHashSettings.ITERATIONS, LiskHashSettings.KEYLEN, LiskHashSettings.DIGEST);
        const keyPair = sodium_browserify_tweetnacl_1.default.crypto_sign_seed_keypair(liskSeed);
        const address = cryptography.getBase32AddressFromPublicKey(keyPair.publicKey);
        const addressHexBinary = cryptography.getAddressFromPublicKey(keyPair.publicKey);
        const addressHex = (0, encryptor_1.bytesToHex)(addressHexBinary);
        const privateKey = keyPair.secretKey.toString('hex');
        return {
            network,
            keyPair,
            address,
            addressHexBinary,
            addressHex,
            privateKey,
        };
    },
};
